<?php
/**
 * Magento
 * @category   Payment
 * @package    Pdt_bitpay
 * @copyright  Copyright (c) 2013 bitpay developement team(info@bitpay.ir)
 * @see http://bitpay.ir
 */
class Pdt_bitpay_Block_Redirect extends Mage_Core_Block_Template
{
    /**
     * Return checkout session instance
     *
     * @return Mage_Checkout_Model_Session
     */
    protected function _getCheckout()
    {
        return Mage::getSingleton('checkout/session');
    }

    /**
     * Return order instance
     *
     * @return Mage_Sales_Model_Order|null
     */
    protected function _getOrder()
    {
        if ($this->getOrder()) {
            return $this->getOrder();
        } elseif ($orderIncrementId = $this->_getCheckout()->getLastRealOrderId()) {
            return Mage::getModel('sales/order')->loadByIncrementId($orderIncrementId);
        } else {
            return null;
        }
    }

    /**
     * Get form data
     *
     * @return array
     */
    public function getFormData()
    {
        #return $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
	$order = $this->_getOrder()->_data;
	$array = $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
	$price = $array["price"];
        
    $seller_id = $this->_getOrder()->getPayment()->getMethodInstance()->getConfigData('seller_id');	

	$len = strlen($price);
	$len -= 2;
	$price = substr($price,0,$len);
	
	$params = array(
	 			'pin' => $seller_id ,  
                'amount' => $price,
                'orderId' => $order["entity_id"],
				'authority' => 0,
				'status' => 1
              );
	
	
	return $params;		
    }

    /**
     * Getting gateway url
     *
     * @return string
     */
    public function getFormAction()
    {
    		   
		
		$order = $this->_getOrder()->_data;
		$array = $this->_getOrder()->getPayment()->getMethodInstance()->getFormFields();
		$price = $array["price"];
			
		$seller_id = $this->_getOrder()->getPayment()->getMethodInstance()->getConfigData('seller_id');	
	
		$price = round($order["grand_total"],0);
		
		$callBackUrl = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_LINK);
		$callBackUrl .= "bitpay/processing/response/";
		$redirect_p = urlencode($callBackUrl);
		

		$url_p = 'https://bitpay.ir/payment/gateway-send';
		
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,$url_p);
		curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$seller_id&amount=$price&redirect=$redirect_p");
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$result_p = curl_exec($ch);
		curl_close($ch);
		
		
		if($result_p > 0 && is_numeric($result_p)){
			@session_start();
			$_SESSION['id_get'] = $result_p;
			$_SESSION['order_id'] = $order["entity_id"];
			$return = "https://bitpay.ir/payment/gateway-$result_p";
		}else {
			Mage::log('bitpay ERR: ' . $result->Status);
			echo $result->Status ;
		}
		return $return;
    }
}
