<?php
/**
 * Magento
 * @category   Payment
 * @package    Pdt_bitpay
 * @copyright  Copyright (c) 2013 bitpay developement team(info@bitpay.ir)
 * @see http://bitpay.ir
 */
class Pdt_bitpay_Model_Config_Backend_Sellerid extends Mage_Core_Model_Config_Data
{
    /**
     * Verify seller id in ClickandBuy registration system to reduce configuration failures (experimental)
     *
     * @return Pdt_bitpay_Model_bitpay_Config_Backend_Sellerid
     */
    protected function _beforeSave()
    {
    	try {
    	    if ($this->getValue()) {
    			$client = new Varien_Http_Client();
    			$client->setUri((string)Mage::getConfig()->getNode('pdt/bitpay/verify_url'))
    				->setConfig(array('timeout'=>10,))
    				->setHeaders('accept-encoding', '')
    				->setParameterPost('seller_id', $this->getValue())
    				->setMethod(Zend_Http_Client::POST);
    			$response = $client->request();
//    			$responseBody = $response->getBody();
//    			if (empty($responseBody) || $responseBody != 'VERIFIED') {
    				// verification failed. throw error message (not implemented yet).
//    			}

    			// okay, seller id verified. continue saving.
    	    }
		} catch (Exception $e) {
			// verification system unavailable. no further action.
		}

        return $this;
    }
}
